class MSBHud extends HUD
config (MSBCode);

var string debugString;
var MSBMouseOverlay MouseOverlay;
var MSBController M;

var() config array<String> MenuButtons;
var() array<MSBUserOverlay> UserOverlays;
var bool DrawOverlays;

var MSBDepthOfFieldOverlay DoFOverlay;

//-------------------------------------------------------
// first spawn mouse and connect to interaction class
// then spawn all buttons and add them
// then spawn the MSBDepthOfFieldOverlay
// the add mouse on top
//-------------------------------------------------------
event PostBeginPlay()
{
super.PostBeginPlay();
M=MSBController(Level.GetLocalPlayerController());
MouseOverlay=Spawn(class'MSBMouseOverlay');
spawnBaseMenu();
DofOverlay=Spawn(class'MSBDepthOfFieldOverlay');
AddHudOverlay(MouseOverlay);
}

//-------------------------------------------------------
// this should really be a list, so people can configure their menu themselves...
//-------------------------------------------------------

function spawnBaseMenu()
{
local MSBGuiOverlay buttonOverlay;
local class<MSBGuiOverlay> ButtonClass;
local int i;

for (i=0;i<MenuButtons.length;i++)
  {
  ButtonClass = class<MSBGuiOverlay>(DynamicLoadObject(MenuButtons[i], class'Class'));
  buttonOverlay=Spawn(ButtonClass,self,,M.Location);
  buttonOverlay.xPos=0;
  buttonOverlay.yPos=16+(buttonOverlay.height+4)*i;
  buttonOverlay.Mouse=MouseOverlay;
  AddHudOverlay(buttonOverlay);
  }
}

simulated event PostRender(Canvas C)
{
if (M!=None)
  {
  M.screenX=C.SizeX;
  M.screenY=C.SizeY;
  }
C.SetDrawColor(255,255,255);
C.FontScaleX=1.5;
C.FontScaleY=1.5;
C.DrawText(debugString);
}

defaultproperties
{
drawOverlays=true
}
