class MSBPawnInputControl extends Actor;

var MSBPawn myPawn;
var MSBMouseOverlay Mouse;

var MSBGamePadUdpLink udpLink;
var () int iPort;   // server port number
var bool bUdpInit;

event PostBeginPlay()
{
super.PostBeginPlay();
if (Owner.IsA('MSBPawn'))
  myPawn=MSBPawn(Owner);
}

function initUdp()
{
 iPort=31840+myPawn.UdpPadCh;
 if (udpLink!=None)
   udpLink.Destroy();
 udpLink=Spawn(class'MSBGamePadUdpLink');
 udpLink.InitUdpLink(iPort);
 Log("UdpPort initialized to"@iPort);
}

event Trigger(Actor Other,Pawn EventInstigator)
{
Log(Other);
if (Other.IsA('MSBGuiOverlay'))
  initUdp();
Log("changed UdpPadChannel in MSBPawnInputControl!");
}

function Tick(float DeltaTime)
{
local rotator HeadTurn;
super.Tick(DeltaTime);

//local Gamepad_
if (myPawn!=None && Mouse!=None && myPawn.UdpPadCh==0)
  {
  if (Mouse.pressedKey-199>0 && Mouse.pressedKey-199<17)
    {
    myPawn.setPawnPose(myPawn.PoseName[Mouse.pressedKey-200]);
    Mouse.pressedKey=0;
    }
  myPawn.eyeX=Mouse.joyUAxis;
  myPawn.eyeY=Mouse.joyVAxis;
  myPawn.browY=Mouse.joyYAxis;

  HeadTurn.Yaw=4096*Mouse.joyYAxis/6;
  HeadTurn.Roll=-4096*Mouse.joyXAxis/6;
  if (HeadTurn.Yaw>0 || HeadTurn.Yaw<0 || HeadTurn.Roll>0 || HeadTurn.Roll<0)
    {
    myPawn.SetBoneRotation('Bip01 Head',HeadTurn);
    }
  }

//udp Gamepad_
if (myPawn!=None && Mouse!=None && myPawn.UdpPadCh>0 && udpLink!=None)
  {
  if (udpLink.ButtonNumber>0 && udpLink.ButtonNumber<17)
    {
    myPawn.setPawnPose(myPawn.PoseName[udpLink.ButtonNumber-1]);
    udpLink.ButtonNumber=0;
    }

  myPawn.eyeX=udpLink.joyUAxis;
  myPawn.eyeY=udpLink.joyVAxis;
  myPawn.browY=udpLink.joyYAxis;

  HeadTurn.Yaw=4096*udpLink.joyYAxis;
  HeadTurn.Roll=-4096*udpLink.joyXAxis;
  if (VSize(vector(HeadTurn))>0)
    myPawn.SetBoneRotation('Bip01 Head',HeadTurn);
  }
}

defaultproperties
{
DrawType=DT_None
iPort=31840
}
