//-----------------------------------------------------------
//    Saving stores relative number references to all objects
//-----------------------------------------------------------
class MSBSceneSaveButton extends MSBListButton;

#exec texture Import File=Textures\saveScene.tga Name=saveScene_Icon Mips=Off Alpha=1

var int sgNumber;
var string sgName;
var string saveName;

event PostBeginPlay()
{
local int i;

super.PostBeginPlay();

for (i=0;i<M.saveGames.length+1;i++)
  ButtonList[i]="MSBPropertyButtons.MSBPropertyButtonText";

}


function LeftBtn(Canvas C)                      //spawns subButtons
{
local int i;
super.LeftBtn(C);

for (i=currentpage*8;i<maxButtons;i++)
  {
    MSBPropertyButton(ListButton[i]).Property="saveName";
    MSBPropertyButton(ListButton[i]).Parent=self;
    MSBPropertyButton(ListButton[i]).BtnName="createNew";
    if (i<ButtonList.length-1)
      MSBPropertyButton(ListButton[i]).BtnName=M.SaveGames[i];
  }
}

event Trigger(Actor Other, Pawn EventInstigator)
{
local MSBDataObject Save;

local MSBNodeButton N;
local MSBScriptNodeButton S;
local MSBExtendedListButton L;

local Actor ActorContainer;

local MSBActor A;
local MSBPawn P;

local int i,j,currentItem;

local string ObjectName, MapName;

Save=Level.Game.CreateDataObject(class'MSBDataObject',SaveName,"MSBSavedScenes");
Save.pcLocation=M.Location;
Save.pcRotation=M.Rotation;
//-------------------------------------------------------------
// MSBScriptNodeButtons
//-------------------------------------------------------------
for(currentItem=0;currentItem<M.LevelMSBScriptNodes.length;currentItem++)
  {
  S=M.LevelMSBScriptNodes[currentItem];
  Save.myMSBScriptNodeInfos.Insert(Save.myMSBScriptNodeInfos.Length,1);
  //---------------------------------------------------
  //Properties, ButtonLists and references are stored
  //---------------------------------------------------
  for (i=0;i<S.Properties.length;i++)
    {
    Save.myMSBScriptNodeInfos[currentItem].Properties[i]=S.Properties[i];
    Save.myMSBScriptNodeInfos[currentItem].ButtonList[i]=S.ButtonList[i];
    Save.myMSBScriptNodeInfos[currentItem].Values[i]=S.GetPropertyText(S.Properties[i]);
    }
  //---------------------------------------------------
  //General Node Properties are stored_
  //---------------------------------------------------
  Save.myMSBScriptNodeInfos[currentItem].myClass=S.Class;
  Save.myMSBScriptNodeInfos[currentItem].xpos=S.xPos;
  Save.myMSBScriptNodeInfos[currentItem].ypos=S.yPos;
  Save.myMSBScriptNodeInfos[currentItem].col=S.col;
  Save.myMSBScriptNodeInfos[currentItem].btnName=S.BtnName;

  for (i=0;i<M.LevelNodes.length;i++)
    if (S.NodeOut.ChildNode.myNode.Order==M.LevelNodes[i].Order && M.LevelNodes[i].Order!=None)
      Save.myMSBScriptNodeInfos[currentItem].NextNode=i+1;
  Log("Scriptnode Link is:"@S.Order.OurNextScript);

  }


//-------------------------------------------------------------
// MSBNodeButtons
//-------------------------------------------------------------
for(currentItem=0;currentItem<M.LevelNodes.length;currentItem++)
  {
  N=M.LevelNodes[currentItem];
  Save.myNodeInfos.Insert(Save.myNodeInfos.Length,1);

  //---------------------------------------------------
  //Properties, ButtonLists and references are stored
  //---------------------------------------------------
  for (i=0;i<N.Properties.length;i++)
   {
    Save.myNodeInfos[currentItem].Properties[i]=N.Properties[i];
    Save.myNodeInfos[currentItem].ButtonList[i]=N.ButtonList[i];
    Save.myNodeInfos[currentItem].Values[i]=N.Order.GetPropertyText(N.Properties[i]);

    //-------------------------------------------------------------
    //check Properties for references to Actors, Pawns and Specials
    //-------------------------------------------------------------
    ObjectName=Save.myNodeInfos[currentItem].Values[i];
    ObjectName=GetItemName(ObjectName);
    ObjectName-="'";
    MapName=Left(string(Level), InStr(string(Level), "."));
    ObjectName=MapName$"."$ObjectName;
    ActorContainer=Actor(FindObject(ObjectName,class'Actor'));

   if (ActorContainer!=None)
   {
    if (ActorContainer.IsA('MSBActor'))
      {
      for (j=0;j<M.LevelActors.length;j++)
        if (M.LevelActors[j]==ActorContainer)
          Save.myNodeInfos[currentItem].ActorReference[i]=j+1;
      }

    else if (ActorContainer.isA('MSBPawn'))
      {
      for (j=0;j<M.LevelPawns.length;j++)
        if (M.LevelPawns[j]==ActorContainer)
          Save.myNodeInfos[currentItem].PawnReference[i]=j+1;
      }

    else if (ActorContainer.isA('Actor'))
      {
      for (j=0;j<M.LevelSpecial.length;j++)
        if (M.LevelSpecial[j]==ActorContainer)
          Save.myNodeInfos[currentItem].SpecialReference[i]=j+1;
       }
    }
   }
  //---------------------------------------------------
  //General Node Properties are stored_
  //---------------------------------------------------
  Save.myNodeInfos[currentItem].OrderClass=N.Order.Class;
  Save.myNodeInfos[currentItem].xpos=N.xPos;
  Save.myNodeInfos[currentItem].ypos=N.yPos;
  Save.myNodeInfos[currentItem].col=N.col;
  Save.myNodeInfos[currentItem].btnName=N.BtnName;
  Save.myNodeInfos[currentItem].bHiddenBranch=N.bHiddenBranch;

  //---------------------------------------------------
  //special Treament for MSBRootNode
  //---------------------------------------------------
  if (N.Order.IsA('MSBRootNode'))
    {
    Log("dealing wih a RootNode");
    for (i=0;i<M.LevelPawns.length;i++)
      if (MSBRootNode(N.Order).BasePawn==M.LevelPawns[i])
        Save.myNodeInfos[currentItem].PawnReference[0]=i+1;
    }

  //---------------------------------------------------
  //special Treament for MSBSpriteNode
  //---------------------------------------------------
  if (N.Order.IsA('MSBSpriteNode'))
    {
    Log("dealing with a SpriteNode");
    for (i=0;i<M.LevelActors.length;i++)
      if (MSBSpriteNode(N.Order).BasePawn==M.LevelActors[i])
        Save.myNodeInfos[currentItem].PawnReference[0]=i+1;
    }

  //---------------------------------------------------
  // inter-MSBNodeButton Links are stored_
  //---------------------------------------------------
  for (i=0;i<M.LevelNodes.Length;i++)
    if (N.Order.OurNextScript==M.LevelNodes[i].Order)
      Save.myNodeInfos[currentItem].NextNode=i+1;
  }

//-------------------------------------------------------------
// ComplexButtons (MSBExtendedListButton and Children)
//-------------------------------------------------------------
for(currentItem=0;currentItem<M.LevelComplexButtons.length;currentItem++)
  {
  L=M.LevelComplexButtons[currentItem];
  Save.myComplexInfos.Insert(Save.myComplexInfos.Length,1);

  //---------------------------------------------------
  //Properties, ButtonLists and references are stored
  //---------------------------------------------------
  for (i=0;i<L.Properties.length;i++)
    {
    Save.myComplexInfos[currentItem].Properties[i]=L.Properties[i];
    Save.myComplexInfos[currentItem].ButtonList[i]=L.ButtonList[i];
    Save.myComplexInfos[currentItem].Values[i]=L.GetPropertyText(L.Properties[i]);

    //-------------------------------------------------------------
    //check Properties for references to Actors, Pawns and Specials
    //-------------------------------------------------------------
    ObjectName=Save.myComplexInfos[currentItem].Values[i];
    ObjectName=GetItemName(ObjectName);
    ObjectName-="'";
    MapName=Left(string(Level), InStr(string(Level), "."));
    ObjectName=MapName$"."$ObjectName;

    ActorContainer=Actor(FindObject(ObjectName,class'Actor'));
    Log("found Reference:"@ActorContainer);
   if (ActorContainer!=None)
   {
    if (ActorContainer.IsA('MSBActor'))
      {
      for (j=0;j<M.LevelActors.length;j++)
        if (M.LevelActors[j]==ActorContainer)
          Save.myComplexInfos[currentItem].ActorReference[i]=j+1;
      }

    else if (ActorContainer.isA('MSBPawn'))
      {
      for (j=0;j<M.LevelPawns.length;j++)
        if (M.LevelActors[j]==ActorContainer)
          Save.myComplexInfos[currentItem].PawnReference[i]=j+1;
      }

    else if (ActorContainer.isA('Actor'))
      {
      for (j=0;j<M.LevelSpecial.length;j++)
        if (M.LevelSpecial[j]==ActorContainer)
          Save.myComplexInfos[currentItem].SpecialReference[i]=j+1;
       }
    Log("successful reference:"$ActorContainer@Save.myNodeInfos[currentItem].ActorReference[i]);
    }
    }
  //---------------------------------------------------
  //General Button Properties are stored_
  //---------------------------------------------------
  Save.myComplexInfos[currentItem].ButtonClass=L.Class;
  Save.myComplexInfos[currentItem].xpos=L.xPos;
  Save.myComplexInfos[currentItem].ypos=L.yPos;
  Save.myComplexInfos[currentItem].col=L.col;
  Save.myComplexInfos[currentItem].btnName=L.BtnName;
  }

//-------------------------------------------------------------
// MSBActors
//-------------------------------------------------------------
for (currentItem=0;currentItem<M.LevelActors.length;currentItem++)
  {
  A=M.LevelActors[currentItem];
  Save.myActorInfos.Insert(Save.myActorInfos.Length,1);

  //---------------------------------------------------
  // Properties and MSBPropertyButtons
  //---------------------------------------------------
  for (i=0;i<A.Properties.length;i++)
    {
    Save.myActorInfos[currentItem].Properties[i]=A.Properties[i];
    Save.myActorInfos[currentItem].ButtonList[i]=A.ButtonList[i];
    Save.myActorInfos[currentItem].Values[i]=A.GetPropertyText(A.Properties[i]);
    }

  //---------------------------------------------------
  //Location, Rotation and ActorClass
  //---------------------------------------------------
  Save.myActorInfos[currentItem].Location=A.Location;
  Save.myActorInfos[currentItem].Rotation=A.Rotation;
  Save.myActorInfos[currentItem].ActorClass=A.Class;
  Save.myActorInfos[currentItem].DrawScale3D=A.DrawScale3D;
  Save.myActorInfos[currentItem].content=A.content;
  Log("from Save - MSBActor is of Class:"@A.Class);
  //---------------------------------------------------
  //Attachments are stored relatively
  //---------------------------------------------------
  for (i=0;i<M.LevelActors.Length;i++)
    if (A.AttachedTo==M.LevelActors[i])
      Save.myActorInfos[currentItem].attachedTo=i+1;

  for (i=0;i<M.LevelPawns.Length;i++)
    if (A.AttachedTo==M.LevelPawns[i])
      Save.myActorInfos[currentItem].attachedToPawn=i+1;

  for (i=0;i<M.LevelSpecial.Length;i++)
    if (A.AttachedTo==M.LevelSpecial[i])
      Save.myActorInfos[currentItem].attachedToSpecial=i+1;
  //---------------------------------------------------
  //KeyFrames are stored relatively as well
  //---------------------------------------------------
  for (i=0;i<M.LevelActors.Length;i++)     //compare every Actor with every Keyframe of the current Actor
    for(j=0;j<A.Keys.Length;j++)
      if (A.Keys[j]==M.LevelActors[i])
        Save.myActorInfos[currentItem].KeyFrames[j]=i+1;
  }

//-------------------------------------------------------------
// MSBPawns
//-------------------------------------------------------------
for (currentItem=0;currentItem<M.LevelPawns.length;currentItem++)
  {
  P=M.LevelPawns[currentItem];
  Save.myPawnInfos.Insert(Save.myPawnInfos.Length,1);

  //---------------------------------------------------
  // Properties and MSBPropertyButtons
  //---------------------------------------------------
  for (i=0;i<P.Properties.length;i++)
    {
    Save.myPawnInfos[currentItem].Properties[i]=P.Properties[i];
    Save.myPawnInfos[currentItem].ButtonList[i]=P.ButtonList[i];
    Save.myPawnInfos[currentItem].Values[i]=P.GetPropertyText(P.Properties[i]);
    }

  //---------------------------------------------------
  //Location, Rotation and ActorClass
  //---------------------------------------------------
  Save.myPawnInfos[currentItem].Location=P.Location;
  Save.myPawnInfos[currentItem].Rotation=P.Rotation;
  Save.myPawnInfos[currentItem].DrawScale3D=P.DrawScale3D;
  Save.myPawnInfos[currentItem].PawnClass=P.Class;


  //---------------------------------------------------
  //Control related
  //---------------------------------------------------
  for (i=0;i<16;i++)
    {
    Save.myPawnInfos[currentItem].PoseName[i]=P.PoseName[i];
    Log("Saving Pad Pose"@P.PoseName[i]);
    }
  Save.myPawnInfos[currentItem].channel=P.channel;
  Save.myPawnInfos[currentItem].UdpPadChannel=P.UdpPadCh;
  Save.myPawnInfos[currentItem].content=P.content;

  //---------------------------------------------------
  //Attachments are stored relatively
  //---------------------------------------------------
  for (i=0;i<M.LevelActors.Length;i++)
    if (P.AttachedTo==M.LevelActors[i])
      Save.myPawnInfos[currentItem].attachedToActor=i+1;

  for (i=0;i<M.LevelPawns.Length;i++)
    if (P.AttachedTo==M.LevelPawns[i])
      Save.myPawnInfos[currentItem].attachedTo=i+1;

  for (i=0;i<M.LevelSpecial.Length;i++)
    if (P.AttachedTo==M.LevelSpecial[i])
      Save.myPawnInfos[currentItem].attachedToSpecial=i+1;
  }

Level.Game.SavePackage("MSBSavedScenes");

//update SaveGame List
for (i=0;i<ListButton.Length;i++)
  if (Other==ListButton[i] && i< ListButton.Length)
    M.SaveGames[i]=saveName;

M.SaveGeneralConfig();
deSelectSubLevel();
}


DefaultProperties
{
Mat=saveScene_Icon
tooltip="Save Scene"
}
